package com.madeu.controller.mobile.mobilemembership;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobilemembership.MobileMembershipService;
import com.madeu.service.web.webhome.WebHomeService;
import com.madeu.service.web.webmenu.WebMenuService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class MobileMembershipController extends ManagerDraftAction{

	@Autowired
	private MobileMembershipService mobileMembershipService;

	/**
	 * 멤버십층전내역 리스트 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/mobilemembership/selectListMembershipChargeIntro.do")
	public String  selectListMembershipChargeIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileMembershipController  selectListMembershipChargeIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try {
			if (!mobileCheckLogin(session)) {
				return "/mobile/login/login";
			} else {
			}
		} catch (Exception e) {
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobileMembershipController  selectListMembershipChargeIntro END");
		return "/mobile/membership/selectListMembershipCharge";
	}

	/**
	 * 멤버십사용내역 리스트 화면으로 이동.
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilemembership/selectListMembershipUseIntro.do")
	public String  selectListMembershipUseIntro(HttpSession session,HttpServletRequest request, Model model) {
		log.debug("MobileMembershipController  selectListMembershipUseIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try {
			if (!mobileCheckLogin(session)) {
				return "/mobile/login/login";
			} else {
			}
		} catch (Exception e) {
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobileMembershipController  selectListMembershipUseIntro END");
		return "/mobile/membership/selectListMembershipUse";
	}

	/**
	 * 멤버십 잔액 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilemembership/selectTotalMembershipBalance.do")
	public ModelAndView selectTotalMembershipBalance(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileMembershipController selectTotalMembershipBalance START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMembershipService.selectTotalMembershipBalance(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileMembershipController selectTotalMembershipBalance END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 멤버십 사용내역 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilemembership/selectListMembershipUse.do")
	public ModelAndView selectListMembershipUse(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileMembershipController selectListMembershipUse START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMembershipService.selectListMembershipUse(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileMembershipController selectListMembershipUse END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 멤버십 충전내역 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value="/mobilemembership/selectListMembershipCharge.do")
	public ModelAndView selectListMembershipCharge(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileMembershipController selectListMembershipCharge START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMembershipService.selectListMembershipCharge(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileMembershipController selectListMembershipCharge END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}